用条件注释判断浏览器版本解决页面兼容问题

【字号: 日期:2024-03-23浏览:56作者:雯心

对于浏览器兼容问题,我们应该碰到很多了,在平时写一些页面时,在IE8、IE9上可能好好的,当我们在IE6、IE7或者是其他的浏览器上再浏览这些页面时,可能会发现我们的页面已经面目全非了,作为一名前端开发人员,这是最让人发疯的问题了,那么我们该怎么解决这些问题呢? 首先,我们写的页面在不同的浏览器上之所以会出现表现不同的问题,是因为不同的浏览器在解析页面时,他们所遵循的规则并不是完全相同的。比如IE,不同的版本解析都不同,何况是不同的浏览器厂商,不同的内核呢。但是我们在遇到兼容性问题时,应该首先检查我们自己写的代码,看看是不是自己的问题,然后再去追究浏览器的问题。还有,在遇到兼容性问题时,不要动不动就用CSS Hack技术,因为CSS Hack技术并不是W3C所推崇的,因此,不到万不得已,尽量不要用。 好了,说了一大堆,下面我们进入正题: 注释不同的浏览器版本 (1)、支持所有的IE浏览器(不包括IE10标准模式) <!--[if IE]>只有IE6,7,8,9浏览器显示(IE10标准模式不支持)<![endif]--> (2)、所有非IE浏览器(不包括IE10标准模式) <!--[if !IE]><!-->只有非IE浏览器显示(不包括IE10)<!--><![endif]--> (3)、IE10浏览器 目前还没有找到该版本浏览器的像<!--[if IE 9]>似的单独注释,但IE10做得很不错了,就单单布局而言,页面在IE10、FireFox、Chrome上的表现已经没有什么区别了。 (4)、IE9浏览器 <!--[if IE 9]>IE9浏览器显示<hr/><![endif]--> (5)、IE8浏览器 <!--[if IE 8]>IE8浏览器显示<hr/><![endif]--> (6)、IE7浏览器 <!--[if IE 7]>IE7浏览器显示<hr/><![endif]--> (7)、IE6浏览器 <!--[if IE 6]>IE6浏览器显示<hr/><![endif]--> (8)、IE10以下版本浏览器(不包括IE10) <!--[if lt IE 10]>IE10以下版本浏览器显示(不包括IE10)<hr/><![endif]--> (9)、IE9及IE9以下版本浏览器(包括IE9) <!--[if lte IE 9]>IE9及IE9以下版本浏览器显示(包括IE9)<hr/><![endif]--> (10)、IE6以上版本浏览器(不含IE6) <!--[if gt IE 6]>IE6以上版本浏览器显示(不含IE6)<hr/><![endif]--> (11)、IE7及IE7以上版本浏览器 <!--[if gte IE 7]>IE7及IE7以上版本浏览器显示(包含IE7)<hr/><![endif]--> 那么我们该怎么运用呢?我们不可能为了兼容像上面那么写,把整页的内容分别写在不同的注释块内。其实这里有两种方法: 方法1、根据不同的浏览器版本,载入不同的css 如我们需要分别兼容IE6、7、8,我们可以这样做

用条件注释判断浏览器版本解决页面兼容问题

方法2、根据不同的浏览器版本,给html或body挂载不同的类如

用条件注释判断浏览器版本解决页面兼容问题

最后我们看一下lt,lte,gt,gte分别表示什么 lt:小于当前版本 lte:小于或等于当前版本,包括本身 gt:大于当前版本 gte:大于或等于当前版本,包括本身 好了,我们今天就到这里,大家可能已经知道怎么简单的处理浏览器兼容了,那么下次我们接着介绍一些CSS Hack技术,更进一步的处理浏览器兼容 测试代码:

用条件注释判断浏览器版本解决页面兼容问题

相关文章: